// Licensed to Cloudera, Inc. under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  Cloudera, Inc. licenses this file
// to you under the Apache License, Version 2.0 (the
// 'License'); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an 'AS IS' BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

import React, { SVGProps } from 'react';

const OzoneIcon = (props: SVGProps<SVGSVGElement>): JSX.Element => (
  <svg viewBox="0 0 24 24" width="1em" height="1em" {...props}>
    <defs>
      <radialGradient
        id="ic-ozone_svg__a"
        cx="274.34%"
        cy="-407.035%"
        r="677.432%"
        fx="274.34%"
        fy="-407.035%"
        gradientTransform="matrix(1 0 0 .89792 0 -.415)"
      >
        <stop offset="0%" stopColor="#474747" />
        <stop offset="53.48%" stopColor="#454545" />
        <stop offset="82.31%" stopColor="#3D3D3D" />
        <stop offset="100%" stopColor="#333" />
      </radialGradient>
      <radialGradient
        id="ic-ozone_svg__b"
        cx="274.345%"
        cy="-407.011%"
        r="750.983%"
        fx="274.345%"
        fy="-407.011%"
        gradientTransform="matrix(1 0 0 .80248 0 -.804)"
      >
        <stop offset="0%" stopColor="#474747" />
        <stop offset="53.48%" stopColor="#454545" />
        <stop offset="82.31%" stopColor="#3D3D3D" />
        <stop offset="100%" stopColor="#333" />
      </radialGradient>
      <radialGradient
        id="ic-ozone_svg__c"
        cx="274.331%"
        cy="-407.025%"
        r="635.753%"
        fx="274.331%"
        fy="-407.025%"
        gradientTransform="matrix(.7851 0 0 1 .59 0)"
      >
        <stop offset="0%" stopColor="#474747" />
        <stop offset="53.48%" stopColor="#454545" />
        <stop offset="82.31%" stopColor="#3D3D3D" />
        <stop offset="100%" stopColor="#333" />
      </radialGradient>
      <radialGradient
        id="ic-ozone_svg__d"
        cx="274.363%"
        cy="-406.96%"
        r="617.582%"
        fx="274.363%"
        fy="-406.96%"
        gradientTransform="matrix(1 0 0 .99494 0 -.02)"
      >
        <stop offset="0%" stopColor="#474747" />
        <stop offset="53.48%" stopColor="#454545" />
        <stop offset="82.31%" stopColor="#3D3D3D" />
        <stop offset="100%" stopColor="#333" />
      </radialGradient>
    </defs>
    <g fill="none" fillRule="evenodd">
      <path d="M12.3 7.607H8.469l3.526-3.427a6.083 6.083 0 00-.65-.034c-3.464 0-6.281 2.892-6.281 6.448 0 1.239.342 2.398.935 3.381 2.235-2.18 5.468-5.469 6.3-6.368zm-5.988 6.841a6.385 6.385 0 002.009 1.796l1.436-1.796H6.312zm5.032 2.593c2.81 0 5.195-1.905 5.994-4.523a229.037 229.037 0 01-6.27 4.516c.091.005.183.007.276.007zm4.391-7.046h1.862a6.592 6.592 0 00-.327-1.535c-.765.736-1.358 1.325-1.535 1.535z" />
      <g fillRule="nonzero">
        <path
          fill="url(#ic-ozone_svg__a)"
          d="M3.653 13.145H3.22l.267-.26a6.846 6.846 0 01-1.012-3.594c0-3.723 2.95-6.751 6.575-6.751.476 0 .94.052 1.386.151h4.976C13.776 1.03 11.527 0 9.05 0 4.059 0 0 4.168 0 9.29c0 3.314 1.7 6.228 4.249 7.873l1.586-1.984a6.713 6.713 0 01-2.182-2.034z"
          transform="translate(2.295 1.303)"
        />
        <path
          fill="url(#ic-ozone_svg__b)"
          d="M15.598 8.691h2.48a9.412 9.412 0 00-.946-3.574c-.656.61-1.33 1.246-1.922 1.814.202.556.335 1.147.388 1.76z"
          transform="translate(2.295 1.303)"
        />
        <path
          fill="url(#ic-ozone_svg__c)"
          d="M18.088 8.867c-.862.686-1.75 1.373-2.66 2.058-.713 2.936-3.302 5.117-6.38 5.117-.225 0-.45-.012-.67-.035-.576.401-1.15.798-1.719 1.191-.311.247-.623.491-.935.734a8.78 8.78 0 003.325.65c4.99 0 9.049-4.168 9.049-9.29 0-.143-.004-.285-.01-.425z"
          transform="translate(2.295 1.303)"
        />
        <path
          fill="url(#ic-ozone_svg__d)"
          d="M6.29 15.418c-.063-.03-.126-.062-.189-.094l-1.597 1.998.156.092.508-.49c.472-.454.948-.912 1.415-1.375a6.987 6.987 0 01-.292-.13z"
          transform="translate(2.295 1.303)"
        />
      </g>
      <path
        fill="#FFF"
        fillRule="nonzero"
        d="M22.123 3.994H18.12C16.416 2.151 14.01 1 11.344 1 6.192 1 2 5.304 2 10.594 2 14.002 3.74 17 6.356 18.702l-3.325 4.16.83-.571a87.291 87.291 0 003.885-2.844 9.076 9.076 0 003.598.74c5.152 0 9.344-4.303 9.344-9.593 0-1.579-.373-3.07-1.034-4.384 1.037-.963 1.996-1.83 2.469-2.216zm-1.73 6.6c0 5.122-4.06 9.29-9.049 9.29a8.784 8.784 0 01-3.325-.65c.312-.242.624-.486.935-.733.57-.393 1.143-.79 1.719-1.191.22.023.445.035.671.035 3.077 0 5.667-2.181 6.38-5.117.908-.685 1.798-1.372 2.66-2.059.006.141.009.283.009.425zm-9.049-9.29c2.479 0 4.727 1.028 6.363 2.69h-4.975a6.421 6.421 0 00-1.387-.151c-3.626 0-6.576 3.028-6.576 6.75 0 1.321.372 2.554 1.012 3.596l-.266.259h.434a6.692 6.692 0 002.182 2.034l-1.586 1.984c-2.55-1.645-4.25-4.559-4.25-7.872 0-5.123 4.06-9.29 9.05-9.29zm2.576 6c.07.021-3.727 3.889-6.24 6.354l-.462.452-.036.035h4.184c-.675.843-1.448 1.666-2.255 2.475a5.885 5.885 0 01-.523-.233l1.792-2.242H6.255c.012-.01.023-.023.035-.035l.026-.025a319.294 319.294 0 005.714-5.756c.764-.798.763-.804.739-.907l-.022-.087-.102-.03h1.275zM12.75 4.31c.124.03.246.062.366.1l-.387.375-.024.024-2.453 2.384-.116.112H9.21l3.093-3.007h.395l.052.012zM8.47 7.607h3.83c-.832.9-4.066 4.188-6.3 6.368a6.529 6.529 0 01-.935-3.381c0-3.556 2.817-6.448 6.28-6.448.22 0 .437.011.65.034L8.47 7.607zm1.287 6.84L8.32 16.245a6.38 6.38 0 01-2.008-1.796h3.444zm-1.17 2.274c.096.046.194.09.292.13-.466.463-.942.921-1.414 1.376l-.509.49c-.052-.03-.104-.06-.156-.092l1.598-1.998c.062.033.125.064.19.094zm8.752-4.203c-.799 2.618-3.184 4.523-5.994 4.523-.093 0-.185-.002-.277-.006 2.105-1.47 4.23-2.987 6.271-4.517zm-1.603-2.523c.177-.21.77-.8 1.535-1.535.167.487.278 1.002.327 1.535h-1.862zM6.73 18.934c-.278.27-.553.538-.822.805l.702-.877.12.072zm11.163-8.94a6.85 6.85 0 00-.388-1.76c.592-.567 1.266-1.203 1.922-1.814a9.412 9.412 0 01.946 3.575h-2.48z"
      />
      <path
        fill="#6CB944"
        fillRule="nonzero"
        d="M18.388 4.297h-6.084L9.211 7.304h3.434l.102.03.022.087c.024.104.026.11-.739.907a319.932 319.932 0 01-5.714 5.757l-.026.025-.035.035h4.125l-1.792 2.242-.098.122-.095.118L6.8 18.625l-.097.122-.092.115-.702.878-1.367 1.71a89.374 89.374 0 002.895-2.143l.132-.101.137-.107c.794-.615 1.582-1.242 2.37-1.88l.154-.125.157-.127c1.18-.96 2.364-1.944 3.57-2.947 1.19-.989 2.41-2.003 3.656-3.017l.154-.125.152-.124.565-.456h-4.367l.21-.25c.028-.033.064-.074.11-.122.374-.402 1.348-1.35 2.44-2.383l.113-.108.11-.104c.416-.393.845-.794 1.259-1.177.207-.193.412-.381.609-.562l.114-.105.109-.099c.361-.33.694-.628.976-.876l.154-.135.066-.057.013-.011.014-.012h-2.025z"
      />
      <path
        fill="#6AA74D"
        fillRule="nonzero"
        d="M14.452 9.917c.235-.281 1.274-1.27 2.426-2.37l.114-.107.11-.104a160.721 160.721 0 011.864-1.745l.114-.105.109-.1c.382-.348.72-.651.977-.873l.232-.197-.011.004-1.535.569-.14.052-.15.056-1.953.724-.528.196-.15.055-.155.058-1.52.563.18 3.333"
      />
      <path
        fill="#7DC159"
        fillRule="nonzero"
        d="M20.4 4.309h-8.048l-.006.006-.03.03.388.463 1.494 1.785 1.571-.569.157-.056.15-.055.532-.192 1.962-.71.15-.055.142-.05 1.457-.528.005-.002c.025-.02.05-.04.072-.06l.009-.006h-.007v-.001z"
      />
      <path
        d="M10.253 7.192l3.946-.599-1.469-1.808-.382-.47-.005-.006-3.104 2.996-.051.049.325-.049zm8.09 3.129l-.425.133-.147.046-.147.046-9.943 3.112-1.364.426-.082.025h3.898l7.49-3.414.149-.068.147-.067.51-.232.01-.007h-.096z"
        fill="#A2DD8A"
        fillRule="nonzero"
        opacity={0.32}
      />
      <path
        d="M5.5 20.484l-.18.175c.056-.049.116-.107.18-.175zm12.723-10.007l-.304.144-.148.07-.149.07-7.186 3.383-.086.04a70.41 70.41 0 01-1.585 2.288l-.09.126-.089.123a63.105 63.105 0 01-1.544 2.045l-.097.12-.094.117c-.518.639-.995 1.175-1.351 1.48l1.666-1.31.128-.1.133-.105 2.32-1.825.15-.117.154-.122 7.563-5.947.153-.12.15-.119.306-.24c-.007.004-.013.009 0 0zm.056.068l.018-.014-.02.014z"
        fill="#64AE41"
        fillRule="nonzero"
        opacity={0.08}
      />
    </g>
  </svg>
);

export default OzoneIcon;
